/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.sample.job01;

import jp.terasoluna.fw.batch.core.AbstractCollector;
import jp.terasoluna.fw.batch.core.CollectedDataHandler;
import jp.terasoluna.fw.batch.core.CollectorResult;
import jp.terasoluna.fw.batch.core.JobStatus;
import jp.terasoluna.fw.batch.openapi.JobContext;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.file.dao.FileException;
import jp.terasoluna.fw.file.dao.FileLineIterator;
import jp.terasoluna.fw.file.dao.FileQueryDAO;

/**
 * 入金データインポートコレクタクラス
 */
public class NyukinImportCollector extends AbstractCollector {

    /**
     * ファイルアクセス用DAO。
     * Springによりインスタンス生成され設定される。
     */
    private FileQueryDAO fileQueryDAO = null;
    
    /**
     * 結果クラス。
     * Springによりインスタンス生成され設定される。
     */
    private Object resultClass = null;

         
    @Override
    protected CollectorResult doCollect(JobContext jobContext,
        CollectedDataHandler handler, JobStatus jobStatus) throws FileException {

        // 処理済行のカウント
        int collected = 0;
        
        //ファイル行オブジェクトを保持するイテレータを取得する
        //(ファイル名はジョブコンテキストより取得する)
        DBJobContext dbJobContext = (DBJobContext) jobContext;
        FileLineIterator fileLineIterator = fileQueryDAO.execute(dbJobContext.getFileName(), 
           resultClass.getClass());
        try {
            
            //ファイル行オブジェクトを処理する
            while (fileLineIterator.hasNext()) {
        	    Object object = fileLineIterator.next();
        	    if (object != null) {
        	    	handler.handle(object, collected++);
        	    	jobStatus.incrementCollected();
        	    }
            }
            
            //コレクター結果オブジェクトを返却する。
            CollectorResult result = new CollectorResult(ReturnCode.NORMAL_END, collected);
            return result;
            
        } catch (FileException e) {
            throw e;
        } finally {
            fileLineIterator.closeFile();
        }
    }

    /**
     * FileQueryDAOを設定する。
     * @param fileQueryDAO FileQueryDAO
     */
    public void setFileQueryDAO(FileQueryDAO fileQueryDAO) {
        this.fileQueryDAO = fileQueryDAO;
    }

   
    /**
     * 結果クラスを設定する。
     * @param resultClass 結果クラス
     */
    public void setResultClass(Object resultClass) {
        this.resultClass = resultClass;
    }

}
